require 'mail/configuration'
require 'app_mail/mail_gem/delivery_method'

module AppMail
  module MailGem
    module ConfigExtension

      def self.load
        Mail::Configuration.send :include, self
      end

      def self.included(base)
        base.class_eval do
          alias_method :lookup_delivery_method_without_appmail, :lookup_delivery_method
          alias_method :lookup_delivery_method, :lookup_delivery_method_with_appmail
        end
      end

      def lookup_delivery_method_with_appmail(method)
        if method == :appmail
          DeliveryMethod
        else
          lookup_delivery_method_without_appmail(method)
        end
      end

    end
  end
end
